> ## Documentation Index
> Fetch the complete documentation index at: https://hoopdev-docs-improve-idp-sso-pages.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Database Role Job

> It creates a job that performs the provisioning of default database roles



## OpenAPI

````yaml https://use.hoop.dev/api/openapiv3.json post /dbroles/jobs
openapi: 3.0.3
info:
  contact:
    email: help@hoop.dev
    name: Help
    url: https://help.hoop.dev
  description: >-
    Hoop.dev is an access gateway for databases and servers with an API for
    packet manipulation
  license:
    name: MIT
    url: https://opensource.org/license/mit
  termsOfService: https://hoop.dev/docs/legal/tos
  title: Hoop Api
  version: 1.49.10
servers:
  - url: https://use.hoop.dev/api
security: []
tags:
  - description: >
      Hoop implements Oauth2 and OIDC protocol to authenticate users in the
      system. To obtain a valid access token users need to authenticate in their
      own identity provider which is generated as a JSON response to the
      endpoint `http(s)://use.hoop.dev/api/login`. The identity provider them
      redirects the user to the callback endpoint containing the access token.


      The recommended approach of obtaining an access token is by visiting the
      Webapp main's page or using the **Hoop command line**. Example:


      ```sh

      hoop config create --api-url https://use.hoop.dev

      # save the token after authenticating at $HOME/.hoop/config.toml

      hoop login

      # show token information

      hoop config view --raw

      ```


      With an access token you could use any HTTP client to interact with the
      documented endpoints.

      The token must be sent through the `Authorization` header.


      Example:


      ```sh

      # obtain the current configuration of the server

      curl https://use.hoop.dev/api/serverinfo -H "Authorization: Bearer
      $ACCESS_TOKEN"

      ```
    name: Authentication
  - description: >
      Users are active and assigned to the default organization when they
      signup. A user could be set to an inactive state preventing it from
      accessing the platform, however it’s recommended to manage the state of
      users in the identity provider.


      - The `sub` claim is used as the main identifier of the user in the
      platform.

      - The profile of the user is derived from the id_token claims `email` and
      `name`.


      When a user authenticates for the first time, it performs an automatic
      signup that persist the profile claims along with it’s unique identifier.

      ​

      ### Groups


      Groups allows defining who may access or interact with certain resources.


      - For connection resources it’s possible to define which groups has access
      to a specific connection, this is enforced when the Access Control feature
      is enabled.

      - For review resources, it’s possible to define which groups are allowed
      to approve an execution, this is enforced when the Review feature is
      enabled.


      > This resource could be managed manually via Webapp or propagated by the
      identity provider via ID Token. In this mode, groups are sync when a user
      performs a login.


      ### Roles


      - The `admin` group is a special role that grants full access to all
      resources


      This role should be granted to users that are responsible for managing the
      Gateway. All other users are regular, meaning that they can access their
      own resources and interact with connections.
    name: User Management
  - description: Routes used to manage and obtain information about the runtime server.
    name: Server Management
  - description: Features available in the gateway. See also **Plugin** resources.
    name: Features
  - description: >-
      Proxy manager endpoints controls how clients connect via gRPC in the
      gateway. These endpoints are meant to be used when a client is initialized
      via `hoop proxy-manager`.
    name: Proxy Manager
  - name: Connections
  - name: Agents
  - name: Runbooks
  - name: Guard Rails
  - name: Reviews
  - name: Sessions
  - name: Organization Management
  - name: Reports
paths:
  /dbroles/jobs:
    post:
      tags:
        - AWS
      summary: Create Database Role Job
      description: >-
        It creates a job that performs the provisioning of default database
        roles
      requestBody:
        content:
          '*/*':
            schema:
              $ref: '#/components/schemas/openapi.CreateDBRoleJob'
        description: The request body resource
        required: true
        x-originalParamName: request
      responses:
        '202':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.CreateDBRoleJobResponse'
          description: Accepted
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Bad Request
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Internal Server Error
components:
  schemas:
    openapi.CreateDBRoleJob:
      properties:
        agent_id:
          description: Unique identifier of the agent hosting the database resource
          example: a1b2c3d4-e5f6-7890-abcd-ef1234567890
          format: uuid
          minLength: 36
          type: string
        aws:
          allOf:
            - $ref: '#/components/schemas/openapi.CreateDBRoleJobAWSProvider'
          description: AWS-specific configuration for the database role creation job
        connection_prefix_name:
          description: >-
            Base prefix for connection names - the role name will be appended to
            this prefix

            when creating the database connection (e.g., "prod-postgres-ro")
          example: prod-postgres-
          type: string
        job_steps:
          description: The additional steps to execute
          example:
            - create-connections
            - send-webhook
          items:
            $ref: '#/components/schemas/openapi.DBRoleJobStepType'
          type: array
        vault_provider:
          allOf:
            - $ref: '#/components/schemas/openapi.DBRoleJobVaultProvider'
          description: >-
            Vault Provider uses HashiCorp Vault to store the provisioned
            credentials.

            The target agent must be configured with the Vault Credentials in
            order for this operation to work
      required:
        - agent_id
        - aws
        - connection_prefix_name
        - job_steps
      type: object
    openapi.CreateDBRoleJobResponse:
      properties:
        job_id:
          description: >-
            Unique identifier for the asynchronous job that will create the
            database role
          example: 8F680C64-DBFD-48E1-9855-6650D9CAD62C
          type: string
      type: object
    openapi.HTTPError:
      properties:
        message:
          example: the error description
          type: string
      type: object
    openapi.CreateDBRoleJobAWSProvider:
      properties:
        default_security_group:
          allOf:
            - $ref: '#/components/schemas/openapi.CreateDBRoleJobAWSProviderSG'
          description: >-
            The default security group that will be used to grant access for the
            agent to access.
        instance_arn:
          description: Instance ARN is the identifier for the database instance
          example: arn:aws:rds:us-west-2:123456789012:db:my-instance
          type: string
      required:
        - instance_arn
      type: object
    openapi.DBRoleJobStepType:
      enum:
        - create-connections
        - send-webhook
      type: string
    openapi.DBRoleJobVaultProvider:
      properties:
        secret_id:
          description: The path to store the credentials in Vault
          example: dbsecrets/data/
          type: string
      required:
        - secret_id
      type: object
    openapi.CreateDBRoleJobAWSProviderSG:
      properties:
        ingress_cidr:
          description: The ingress inbound CIDR rule to allow traffic to
          example: 192.168.1.0/24
          type: string
      required:
        - ingress_cidr
      type: object

````